

;'(gnus-nntp-server "uutiset.elisa.fi")
'(gnus-nntp-server "news.individual.net")

(setq gnus-select-method '(nntp "news.individual.net"))
(setq user-full-name "Juhapekka Tolvanen")
(setq user-mail-address "juhtolv@iki.fi") 

;(add-to-list 'gnus-secondary-select-methods
;             '(nntp "discussion.fastseduction.com")
;             )


; Use topic
(add-hook 'gnus-group-mode-hook 'gnus-topic-mode)

; Stop stealing my disk quota...
(setq gnus-agent-cache nil)

; Disabling Agent altogether, still have a lack of quota...
(setq gnus-agent nil)

(setq nntp-marks-is-evil t)


;; Make Gnus startup faster:

(setq gnus-check-new-newsgroups nil)
(setq gnus-read-active-file nil)
(setq gnus-nov-is-evil nil)
(setq gnus-save-killed-list nil)

;; Handle wide characters right
(setq gnus-use-correct-string-widths t)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Tiny Tools
;;(add-hook 'gnus-startup-hook '(lambda () (require 'tinygnus)))
;;(add-hook 'gnus-startup-hook '(lambda () (load-library tinygnus)))

;; This works:
;(load-library "tinygnus")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PGG
;; http://www.emacswiki.org/cgi-bin/wiki/GnusPGG

;;(require 'pgg)

;; Here we make button for the multipart 
;;(setq gnus-buttonized-mime-types '("multipart/encrypted" "multipart/signed"))


;; Some high-light
(eval-after-load "gnus-art"
  '(progn

     (set-face-foreground 'gnus-header-content-face "white")
     (set-face-background 'gnus-header-content-face "blue")

     (set-face-foreground 'gnus-header-from-face "black")
     (set-face-background 'gnus-header-from-face "red")

     (set-face-foreground 'gnus-header-name-face "white")
     (set-face-background 'gnus-header-name-face "blue")

     (set-face-foreground 'gnus-header-newsgroups-face "white")
     (set-face-background 'gnus-header-newsgroups-face "black")

     (set-face-foreground 'gnus-header-subject-face "black")
     (set-face-background 'gnus-header-subject-face "red")

     (set-face-foreground 'gnus-signature-face "white")
     (set-face-background 'gnus-signature-face "brightblue")

     )
  )


;; How to sort threads:

;;*================================
;;* Formatting the summary buffer: sorting by thread
;* gnus-thread-sort-by-author     - Sort threads by root author.
;* gnus-thread-sort-by-chars      - Sort threads by root article octet length.
;* gnus-thread-sort-by-date       - Sort threads by root article date.
;* gnus-thread-sort-by-lines      - Sort threads by root article Lines header.
;* gnus-thread-sort-by-number     - Sort threads by root article number.
;* gnus-thread-sort-by-score      - Sort threads by root article score.
;* gnus-thread-sort-by-subject    - Sort threads by root subject.
;* gnus-thread-sort-by-total-score - Sort threads by the sum of all scores in the thread.
;;*================================

(setq gnus-thread-sort-functions
      '(
        gnus-thread-sort-by-number
        gnus-thread-sort-by-chars
        gnus-thread-sort-by-author
        gnus-thread-sort-by-score
        gnus-thread-sort-by-subject
        gnus-thread-sort-by-date
        gnus-thread-sort-by-total-score
        )
      )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Smileys

;;(add-hook 'gnus-article-display-hook 'gnus-smiley-display t)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; picons and X-Face: -headers

;;(setq gnus-use-picons t)
;;(setq gnus-treat-display-picons t)
;;(setq gnus-picons-display-where "article")

;;(setq gnus-picons-refresh-before-display t)

;;(add-hook 'gnus-article-display-hook 'gnus-article-display-picons)
;;(add-hook 'gnus-article-display-hook 'gnus-picons-article-display-x-face)

(add-hook 'gnus-article-display-hook
          '(gnus-smiley-display t)
          '(gnus-article-display-x-face)
          '(gnus-picons-article-display-x-face)
          ;;  '(gnus-article-display-picons)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Tree

;;(setq gnus-tree-minimize-window "20")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; NoCeM

;;(setq gnus-use-nocem t)

;;(setq gnus-article-display-hook
;;      '(gnus-article-de-quoted-unreadable)
;;      )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Big Menubar

;;(load "big-menubar")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Finladization or Finlandisierung

;;(setq gnus-default-posting-charset 'iso-8859-1)
;;(setq message-default-charset 'iso-8859-1)

(setq gnus-default-posting-charset 'iso-8859-1)
(setq message-default-charset 'iso-8859-1)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; From: -header

;;(setq user-mail-address '"FUBAR.juhtolv@iki.fi.SNAFU.invalid")

;;(setq gnus-posting-styles
;;      '(
;;    (".*"
;;     (name "Juhapekka Tolvanen")
;;         (address "SNAFU.juhtolv@iki.fi.FUBAR.invalid")
;;     )
;;    )
;;    )

(setq gnus-posting-styles
      '(
        (".*" ;;default
         (name "Juhapekka Tolvanen")
         (signature-file "~/.signature")
         (organization "What?+ Me organized?+ Never!1")
         ("X-User-Agent-URL" "http://www.gnus.org/")
         )
        (message-news-p        ;; A function symbol: Usenet News
         (address "SNAFU.juhtolv.POW@MIA.iki.RIP.fi.FUBAR.example.com.invalid")
         ("Reply-To" "SNAFU.juhtolv.POW@MIA.iki.RIP.fi.FUBAR.example.com.invalid")
         ("X-FRA-05" "Hej FRA! Det finns ingen anledning att läsa min Usenet News -artikel.")
         ("X-FRA-04" "Jag har ingenting att göra med Devrimci Sol, ETA eller al-Jama'a al-Islamiyya.")
         ("X-FRA-03" "Jag har aldrig gjort Shahada eller tillverkat kärnvapen, jag vet knappt ens vad al-Nour betyder.")
         ("X-FRA-02" "Men tack för visat intresse!")
         ("X-FRA-01" "PS. Terroristattacker kommer knappast att planeras över okrypterade Usenet News -diskussioner. Sabba FRA-lagen på www.hejfra.se")
         )
        (message-mail-p        ;; A function symbol: E-Mail
         (address "juhtolv@iki.fi")
         ("Reply-To" "juhtolv@iki.fi")
         ("X-FRA-05" "Hej FRA! Det finns ingen anledning att läsa mitt mail.")
         ("X-FRA-04" "Jag har ingenting att göra med Hizb al-Mujahidin, Hizbollah eller ETA.")
         ("X-FRA-03" "Jag har aldrig gjort Istishad eller tillverkat brevbomber, jag vet knappt ens vad Al-Khafid betyder.")
         ("X-FRA-02" "Men tack för visat intresse!")
         ("X-FRA-01" "PS. Terroristattacker kommer knappast att planeras över okrypterade mail. Sabba FRA-lagen på www.hejfra.se")
         )
        )
      )

(setq gnus-visible-headers
      (quote
       (
        "^Posted-To:" "^X-CRM114-Status:" "^X-CRM114-Score:"
        "^X-CRM114-Action:" "^X-Reject:" "^X-Spam-Checked:" "^X-Spam-Status:"
        "^X-Spam-Level:" "^X-Spam-Report:" "^X-Spam-Flag:"
        "^X-Spam-Checker-Version:" "^X-Pyzor:" "^X-Spam-Pyzor:"
        "^X-DCC-SdV-Metrics:" "^X-DCC-MessageCare-Metrics:"
        "^X-DCC-dmv.com-Metrics:" "^X-Spam-DCC:" "^X-Virus-Scanned:"
        "^X-scanner:" "^Subject:" "^Newsgroups:" "^Date:" "^From:"
        "^Organization:" "^To:" "^Cc:"  "^X-Debbugs-Cc:" "^[BGF]?Cc:" "^Reply-To:"
        "^Resent-From:" "^Sender:" "^Mail-Followup-To:" "^Followup-To:"
        "^Mail-Copies-To:" "^Apparently-To:" "^Summary:" "^Keywords:"
        "^X-Keywords:" "^X-Mailing-List:" "^Old-Return-Path:" "^Delivered-To:"
        "^In-Reply-To:" "^X-Originating-Email:" "^Message-ID:"
        "^X-Lotus-FromDomain:" "^X-Mailer:" "^x-mailer:" "^X-Newsreader:"
        "^X-Agent:" "^User-Agent:" "^X-Newsreader" "^X-Posting-Agent:"
        "^X-MimeOLE:" "^X-.*URL.*" "^X-Operating-System:" "^X-OS:" "^X-Editor:"
        "^X-Uptime:" "Content-Type:" "^Gnus-Warning:" "^Lines:"
        )
       )
      )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Gnus User Agent Highlighting (following an idea from ... Mutt ;))
;;; See http://www.xs4all.nl/~matto/mutt-themes/muttrcs/guckes.muttrc
;;; + Face definitions
;;;
;;; From: Xavier Maillard <zedek@gnu-rox.org>
;;; Subject: Re: User-Agent X-Mailer headers in normal article view
;;; Newsgroups: gnu.emacs.gnus
;;; Date: Sun, 03 Oct 2004 23:16:22 +0200
;;; Message-ID: <plop873c0vv6xl.fsf@gnu-rox.org>
;;;

(defface gnus-user-agent-good-face
  '((t (:background "black" :foreground "green")))
  "Face to highlight a `good` user agent header.")

(defface gnus-user-agent-unknown-face
  '((t (:background "black" :foreground "orange" :bold t)))
  "Face to highlight an `unknown` user agent header.")

(defface gnus-user-agent-bad-face
  '((t (:background "black" :foreground "red" :bold t)))
  "Face to highlight a `bad` user agent header.")

(setq gnus-user-agent-alist
      '(
        ("Mutt\\|Gnus\\|tin\\|ELM\\|Emacs\\|slrn\\|Xnews\\|Pan\\|Mozilla\\|GNUS\\|Emacs\\|emacs\\|Evolution\\|Novell Evolution\\|Ximian Evolution" gnus-header-name-face  gnus-user-agent-good-face)
        ("pine\\|CrossPoint\\|Eudora\\|Internet Mail Service\\|Microsoft\\|Novell GroupWise\\|Pegasus\\|WinVN\\|PostMe\\|AOL" gnus-header-name-face gnus-user-agent-bad-face)
        ("MT-NewsWatcher\\|Opera\\|trn\\|40tude_Dialog\\|MicroPlanet Gravity\\|MicroPlanet-Gravity\\|Gravity\\|MesNews\\|Forte Agent\\|MacSOUP/2.5\\|MacSOUP/F-2.4.4\\|Forte Free Agent" gnus-header-name-face gnus-user-agent-unknown-face)
        )
      )

;; "Here is the function
;; This one is by lawrence on #emacs
;; I developped my own based on gnus-article-highlight headers but this one is shorter
;; so I prefer to use this one :) "

;; "Note there was a bug. re-search-forward was done from point to end of buffer.
;; Fixed that problem"
(defun gnus-article-user-agent-headers ()
  "Highlight article User Agent headers as specified by `gnus-user-agent-good'."
  (interactive)
  (with-current-buffer gnus-article-buffer
    (let ((buffer-read-only nil))
      (save-restriction
        (article-narrow-to-head)
        (goto-char (point-min))
        (dolist (entry gnus-user-agent-alist)
          (dolist (header '("X-Mailer" "Newsreader" "User-Agent" "X-Newsreader"))
            (save-excursion
              (while (re-search-forward (concat "^" header) nil t)
                (gnus-put-text-property (match-beginning 0)
                                        (match-end 0)
                                        'face (nth 1 entry))
                (when (re-search-forward (concat ": \\(" (nth 0 entry) "\\).*$") nil t)
                  (goto-char (match-beginning 0))
                  (forward-char 1)
                  (gnus-put-text-property (point) ;;(match-beginning 0)
                                          (point-at-eol)
                                          'face (nth 2 entry)))))))))))

(add-hook 'gnus-article-prepare-hook 'gnus-article-user-agent-headers)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Clicking URLs

;;; Galeon
;;(setq browse-url-browser-function 'browse-url-generic
;;      browse-url-generic-program "galeon"
;;      browse-url-generic-args '("-n"))

;;; Firefox
;;; http://www.emacswiki.org/cgi-bin/wiki/BrowseUrl

;;(defun browse-url-firefox-new-tab (url &optional new-window)
;;  "Open URL in a new tab in Firefox."
;;  (interactive (browse-url-interactive-arg "URL: "))
;;  (let ((cmd (shell-command-to-string
;;        (concat "/usr/lib/mozilla-firefox/mozilla-firefox-xremote-client -a firefox 'openURL(" url ",new-tab)'"))))
;;  (unless (string= "" cmd)
;;    (message "Starting Firefox...")
;;    (start-process (concat "firefox " url) nil "/usr/bin/firefox" url)
;;    (message "Starting Firefox...done"))))
;;(setq browse-url-browser-function 'browse-url-firefox-new-tab)


;;(defun browse-url-firefox-new-tab (url &optional new-window)
;;  ;; new-window ignored
;;  "Open URL in a new tab in Mozilla."
;;  (interactive (browse-url-interactive-arg "URL: "))
;;  (unless
;;	  (string= ""
;;			 (shell-command-to-string
;;			  (concat "mozilla-firefox -a firefox -remote 'openURL(" url ",new-tab)'")))
;;	(message "Starting Mozilla Firefox...")
;;	)
;;  )
;;(setq browse-url-browser-function 'browse-url-firefox-new-tab)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Use 78 characters wide lines automatically,
;; when editing news articles:
;;

(add-hook 'message-mode-hook
          (lambda ()
            (setq fill-column 78)
            (turn-on-auto-fill)
            )
          )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Gnus as mail reader
;;
;; Use Maildir-formatted mail-spool and mail-folders
;; http://www.dotfiles.com/files/30/271_gnus.el
;;

(setq mail-sources nil)
(setq nnmail-spool-file nil)

(add-to-list 'gnus-secondary-select-methods
             '(nnmaildir "" (directory "~/Maildir.mail"))
             )

;(add-to-list 'gnus-secondary-select-methods
;             '(nntp "discussion.fastseduction.com:119")
;             )


;; Avoid marking read articles expirable:
(remove-hook 'gnus-mark-article-hook
             'gnus-summary-mark-read-and-unread-as-read)
(add-hook 'gnus-mark-article-hook 'gnus-summary-mark-unread-as-read)

;; Save sent E-Mail messages to sent-mail-YYYY-MM
;; Save sent Usenet News articles to sent-news-YYYY-MM
(setq gnus-message-archive-group
      '((if (message-news-p)
            (concat "nnmaildir:sent-news-" (format-time-string "%Y-%m"))
          (concat "nnmaildir:sent-mail-" (format-time-string "%Y-%m"))
          )
        )
      )

;; Don't use scoring for E-Mail
(setq gnus-parameters
      '(
        ("^nnmaildir"
         (gnus-use-scoring nil)
         )
        )
      )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Spell-checker

;;(add-hook 'message-mode-hook (lambda () (flyspell-mode 1)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The Insidious Big Brother Database
;;

(add-hook 'gnus-startup-hook 'bbdb-insinuate-gnus)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Handling stupid E-Mail attachments
;; http://www.emacswiki.org/cgi-bin/wiki/MimeTypesWithGnus
;;

;; No HTML mail
;;(setq mm-discouraged-alternatives '("text/html" "text/richtext"))

;; Don't start a browser for text/html only mails
;;(setq mm-automatic-display
;;	  '("text/plain" "text/enriched" "text/richtext"
;;		"image/.*" "message/delivery-status" "multipart/.*" "message/rfc822"
;;		"text/x-patch" "application/pgp-signature" "application/emacs-lisp")
;;	  )

;; Never show vcard stuff, I never need it anyway
;;(setq gnus-ignored-mime-types
;;      '("text/x-vcard")
;;         )

